;================================================================
; LCD - 2 , 16 . 4- ,  .
; 1. Delay_2mS
; 2. Delay_40mkS
; 2. Delay_40mS
; 3. Init_Lcd
; 4. Char2Lcd  ( CHR code into "W" )
; 5. LCD_2Page
; 6. LCD_Scr
;  : Lcd_Count1  Lcd_Count2
#define     CalFosc     .40    ; /4= -  . 
;====================================================
WR_Lcd macro    ;   LCD
                nop
      bsf   Lcd_E
      nop
      bcf   Lcd_E
      endm
;---------------------------------------------
LCD_2Page
      bcf   Lcd_E
      bcf   Lcd_RS
      bsf   Lcd_D7
      bsf   Lcd_D6
      bcf   Lcd_D5
      bcf   Lcd_D4
      WR_Lcd
      bcf   Lcd_D7
      bcf   Lcd_D6
      WR_Lcd
      call  Delay_40mkS
      return
; -----------------------------------------
LCD_Scr               ; Clrf ,  - 0;0.
      bcf   Lcd_E
      bcf   Lcd_RS
      bcf   Lcd_D7
      bcf   Lcd_D6
      bcf   Lcd_D5
      bcf   Lcd_D4
      WR_Lcd
      bsf   Lcd_D4      ;   
      WR_Lcd
      call  Delay_2mS
      bcf   Lcd_D4
      return
; -----------------------------------------
Char2Lcd
      movwf Lcd_Count2
      bsf   Lcd_RS
      bcf   Lcd_D7  ; 
      bcf   Lcd_D6
      bcf   Lcd_D5
      bcf   Lcd_D4
      btfsc Lcd_Count2,7  ;  
      bsf   Lcd_D7
      btfsc Lcd_Count2,6
      bsf   Lcd_D6
      btfsc Lcd_Count2,5
      bsf   Lcd_D5
      btfsc Lcd_Count2,4
      bsf   Lcd_D4
      WR_Lcd
      bcf   Lcd_D7  ; 
      bcf   Lcd_D6
      bcf   Lcd_D5
      bcf   Lcd_D4
      btfsc Lcd_Count2,3  ;  
      bsf   Lcd_D7
      btfsc Lcd_Count2,2
      bsf   Lcd_D6
      btfsc Lcd_Count2,1
      bsf   Lcd_D5
      btfsc Lcd_Count2,0
      bsf   Lcd_D4
      WR_Lcd
      bcf   Lcd_RS
      bcf   Lcd_D7
      bcf   Lcd_D6
      bcf   Lcd_D5
      bcf   Lcd_D4
      call  Delay_40mkS
      return
; -----------------------------------------
Init_Lcd           ;    
      bcf   Lcd_E
      bcf   Lcd_RS
      bsf   Lcd_D4
      bsf   Lcd_D5
      bcf   Lcd_D6
      bcf   Lcd_D7
		call	Delay_40mS
      WR_Lcd
      call  Delay_40mkS
      WR_Lcd
      call  Delay_40mkS
      WR_Lcd
      call  Delay_40mkS
      bcf   Lcd_D4            ;   - 4 
      WR_Lcd
      bsf   Lcd_D7      ;   
      bcf   Lcd_D5
      WR_Lcd
      bcf   Lcd_D7      ; -, 
      call  Delay_40mkS
      WR_Lcd
      bsf   Lcd_D7      ;   
      WR_Lcd
      bcf   Lcd_D7      ; Clrf ,  - 0;0.
      call  Delay_40mkS
      WR_Lcd
      bsf   Lcd_D4      ;   
      WR_Lcd
      bcf   Lcd_D4      ;  
      call  Delay_2mS
      WR_Lcd
      bsf   Lcd_D6      ;   
      bsf   Lcd_D5
      WR_Lcd
      bcf   Lcd_D5      ; ON - LCD
      bcf   Lcd_D6
      call  Delay_40mkS   ; End - init
      WR_Lcd
      bsf   Lcd_D7
      bsf   Lcd_D6
      WR_Lcd
      call  Delay_40mkS
      bcf   Lcd_D7		;  2 
      bcf   Lcd_D6
		bsf	Lcd_D5
      WR_Lcd
      bcf   Lcd_D5
      bsf   Lcd_D7
      WR_Lcd
      call  Delay_40mkS
      bcf   Lcd_D7
      return            ;  .      
; -----------------------------------------
Delay_40mS                       ;  40 
      clrf Lcd_Count2  ; 256 
Delay_40_Loop1
      movlw CalFosc
      movwf Lcd_Count1
Delay_40_Loop2
      decfsz Lcd_Count1,f  ; -1 skip if 0
      goto  Delay_40_Loop2
      decfsz Lcd_Count2,f  ; -1 skip if 0
      goto  Delay_40_Loop1
      clrf Lcd_Count2  ; 256 
Delay_40_Loop1_
      movlw CalFosc
      movwf Lcd_Count1
Delay_40_Loop2_
      decfsz Lcd_Count1,f  ; -1 skip if 0
      goto  Delay_40_Loop2_
      decfsz Lcd_Count2,f  ; -1 skip if 0
      goto  Delay_40_Loop1_
		return
; -----------------------------------------
Delay_2mS
      movlw .25       ; 25 
      movwf Lcd_Count2
Delay_2_Loop1
      movlw CalFosc
      movwf Lcd_Count1
Delay_2_Loop2
      decfsz Lcd_Count1,f  ; -1 skip if 0
      goto  Delay_2_Loop2
      decfsz Lcd_Count2,f  ; -1 skip if 0
      goto  Delay_2_Loop1
      return
; -----------------------------------------
Delay_40mkS
      movlw CalFosc
      movwf Lcd_Count1
      bcf   STATUS,C
      rrf   Lcd_Count1,f ; /2
Delay_4_Loop
      decfsz Lcd_Count1,f  ; -1 skip if 0
      goto  Delay_4_Loop
      return
; -----------------------------------------
